progname=factorial
CC=g++
CFLAGS:=-Wall -Wextra -Werror -g3
#CFLAGS=-Wall -Wextra -Werror -DNDEBUG

ifeq ($(v),rec)
    CFLAGS += -DFACTORIAL_REC
else ifeq ($(v),iter)
    CFLAGS += -DFACTORIAL_ITER
else ifeq ($(v),david)
    CFLAGS += -DFACTORIAL_DAVID
else ifeq ($(v),fast)
    CFLAGS += -DFACTORIAL_FAST
else ifeq ($(v),temp)
    CFLAGS += -DFACTORIAL_TEMPLATE
endif

all: clean test
$(progname): main.o | .gitignore
	$(CC)    $(CFLAGS) $^ -o $@

%.ii: %.cpp
	$(CC) -E $(CFLAGS) $< -o $@

%.s: %.ii
	$(CC) -S $(CFLAGS) $< -o $@

%.o: %.s
	$(CC) -c $(CFLAGS) $< -o $@

.gitignore:
	echo $(progname) > $@

clean:
	rm -f *.ii *.s *.o *.out .gitignore $(progname)

test: $(progname)
	@echo "Running $@..."
	time -p ./$(progname)

.PRECIOUS: main.ii main.s
.SECONDARY: main.ii main.s

